//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <valarray>

#include <conio.h>   //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

//   
template <class T>
void printValarray (const valarray<T>& va)
{
    for (int i=0; i<va.size(); i++) {
        cout << va[i] << ' ';
    }
    cout << endl;
}


int main (int argc, char* argv[])
{
  //      
  valarray<double> va1(10), va2(10);

  //     0.0, 1.1 ... 9.9
  for (int i=0; i<10; i++) {
      va1[i] = i * 1.1;
  }

  //  -1     
  va2 = -1;

    //    
    cout << ToRus("  :\n"); 
    cout << ToRus("1- :\n"); 
    printValarray(va1);
    cout << ToRus("2- :\n"); 
    printValarray(va2);

    //  ,       
    cout << ToRus("1- :\n"); 
    cout << ToRus(": ") << va1.min() << endl;
    cout << ToRus(": ") << va1.max() << endl;
    cout << ToRus(": ") << va1.sum() << endl;

    //     
    va2 = va1;

    //     
    va1.resize(0);

    //     
    cout << ToRus("   :\n"); 
    cout << ToRus("1- :\n"); 
    printValarray(va1);
    cout << ToRus("2- :\n"); 
    printValarray(va2);


  getch();
  return 0;
}

//---------------------------------------------------------------------------